EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_LINE_CLICKED =
   EFL_EVENT_DESCRIPTION("line,clicked");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_LINE_GUTTER_CLICKED =
   EFL_EVENT_DESCRIPTION("line,gutter,clicked");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CHANGED_USER =
   EFL_EVENT_DESCRIPTION("changed,user");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CURSOR_CHANGED =
   EFL_EVENT_DESCRIPTION("cursor,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CODE_SELECTION_START =
   EFL_EVENT_DESCRIPTION("code,selection,start");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CODE_SELECTION_CHANGED =
   EFL_EVENT_DESCRIPTION("code,selection,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CODE_SELECTION_CLEARED =
   EFL_EVENT_DESCRIPTION("code,selection,cleared");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CODE_SELECTION_CUT =
   EFL_EVENT_DESCRIPTION("code,selection,cut");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CODE_SELECTION_COPY =
   EFL_EVENT_DESCRIPTION("code,selection,copy");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_CODE_WIDGET_EVENT_CODE_SELECTION_PASTE =
   EFL_EVENT_DESCRIPTION("code,selection,paste");

void _elm_code_widget_code_set(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code *code);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_code_set, EFL_FUNC_CALL(code), Elm_Code *code);

Elm_Code *_elm_code_widget_code_get(const Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_code_get, Elm_Code *, NULL);

void _elm_code_widget_font_set(Eo *obj, Elm_Code_Widget_Data *pd, const char *name, int size);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_font_set, EFL_FUNC_CALL(name, size), const char *name, int size);

void _elm_code_widget_font_get(const Eo *obj, Elm_Code_Widget_Data *pd, const char **name, int *size);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_code_widget_font_get, EFL_FUNC_CALL(name, size), const char **name, int *size);

unsigned int _elm_code_widget_columns_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_columns_get_reflect(const Eo *obj)
{
   unsigned int val = efl_ui_code_widget_columns_get(obj);
   return eina_value_uint_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_columns_get, unsigned int, 0);

void _elm_code_widget_gravity_set(Eo *obj, Elm_Code_Widget_Data *pd, double x, double y);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_gravity_set, EFL_FUNC_CALL(x, y), double x, double y);

void _elm_code_widget_gravity_get(const Eo *obj, Elm_Code_Widget_Data *pd, double *x, double *y);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_code_widget_gravity_get, EFL_FUNC_CALL(x, y), double *x, double *y);

void _elm_code_widget_policy_set(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Widget_Scroller_Policy policy_h, Elm_Code_Widget_Scroller_Policy policy_v);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_policy_set, EFL_FUNC_CALL(policy_h, policy_v), Elm_Code_Widget_Scroller_Policy policy_h, Elm_Code_Widget_Scroller_Policy policy_v);

void _elm_code_widget_policy_get(const Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Widget_Scroller_Policy *policy_h, Elm_Code_Widget_Scroller_Policy *policy_v);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_code_widget_policy_get, EFL_FUNC_CALL(policy_h, policy_v), Elm_Code_Widget_Scroller_Policy *policy_h, Elm_Code_Widget_Scroller_Policy *policy_v);

void _elm_code_widget_tabstop_set(Eo *obj, Elm_Code_Widget_Data *pd, unsigned int tabstop);


static Eina_Error
__eolian_elm_code_widget_tabstop_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   unsigned int cval;
   if (!eina_value_uint_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_tabstop_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_tabstop_set, EFL_FUNC_CALL(tabstop), unsigned int tabstop);

unsigned int _elm_code_widget_tabstop_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_tabstop_get_reflect(const Eo *obj)
{
   unsigned int val = efl_ui_code_widget_tabstop_get(obj);
   return eina_value_uint_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_tabstop_get, unsigned int, 0);

void _elm_code_widget_editable_set(Eo *obj, Elm_Code_Widget_Data *pd, Eina_Bool editable);


static Eina_Error
__eolian_elm_code_widget_editable_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_editable_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_editable_set, EFL_FUNC_CALL(editable), Eina_Bool editable);

Eina_Bool _elm_code_widget_editable_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_editable_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_code_widget_editable_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_editable_get, Eina_Bool, 0);

void _elm_code_widget_line_numbers_set(Eo *obj, Elm_Code_Widget_Data *pd, Eina_Bool line_numbers);


static Eina_Error
__eolian_elm_code_widget_line_numbers_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_line_numbers_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_line_numbers_set, EFL_FUNC_CALL(line_numbers), Eina_Bool line_numbers);

Eina_Bool _elm_code_widget_line_numbers_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_line_numbers_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_code_widget_line_numbers_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_line_numbers_get, Eina_Bool, 0);

void _elm_code_widget_line_width_marker_set(Eo *obj, Elm_Code_Widget_Data *pd, unsigned int line_width_marker);


static Eina_Error
__eolian_elm_code_widget_line_width_marker_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   unsigned int cval;
   if (!eina_value_uint_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_line_width_marker_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_line_width_marker_set, EFL_FUNC_CALL(line_width_marker), unsigned int line_width_marker);

unsigned int _elm_code_widget_line_width_marker_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_line_width_marker_get_reflect(const Eo *obj)
{
   unsigned int val = efl_ui_code_widget_line_width_marker_get(obj);
   return eina_value_uint_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_line_width_marker_get, unsigned int, 0);

void _elm_code_widget_show_whitespace_set(Eo *obj, Elm_Code_Widget_Data *pd, Eina_Bool show_whitespace);


static Eina_Error
__eolian_elm_code_widget_show_whitespace_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_show_whitespace_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_show_whitespace_set, EFL_FUNC_CALL(show_whitespace), Eina_Bool show_whitespace);

Eina_Bool _elm_code_widget_show_whitespace_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_show_whitespace_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_code_widget_show_whitespace_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_show_whitespace_get, Eina_Bool, 0);

void _elm_code_widget_alpha_set(Eo *obj, Elm_Code_Widget_Data *pd, int alpha);


static Eina_Error
__eolian_elm_code_widget_alpha_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_alpha_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_alpha_set, EFL_FUNC_CALL(alpha), int alpha);

int _elm_code_widget_alpha_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_alpha_get_reflect(const Eo *obj)
{
   int val = efl_ui_code_widget_alpha_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_alpha_get, int, 0);

void _elm_code_widget_syntax_enabled_set(Eo *obj, Elm_Code_Widget_Data *pd, Eina_Bool syntax_enabled);


static Eina_Error
__eolian_elm_code_widget_syntax_enabled_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_syntax_enabled_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_syntax_enabled_set, EFL_FUNC_CALL(syntax_enabled), Eina_Bool syntax_enabled);

Eina_Bool _elm_code_widget_syntax_enabled_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_syntax_enabled_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_code_widget_syntax_enabled_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_syntax_enabled_get, Eina_Bool, 0);

void _elm_code_widget_tab_inserts_spaces_set(Eo *obj, Elm_Code_Widget_Data *pd, Eina_Bool tab_inserts_spaces);


static Eina_Error
__eolian_elm_code_widget_tab_inserts_spaces_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_code_widget_tab_inserts_spaces_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_tab_inserts_spaces_set, EFL_FUNC_CALL(tab_inserts_spaces), Eina_Bool tab_inserts_spaces);

Eina_Bool _elm_code_widget_tab_inserts_spaces_get(const Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Value
__eolian_elm_code_widget_tab_inserts_spaces_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_code_widget_tab_inserts_spaces_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_code_widget_tab_inserts_spaces_get, Eina_Bool, 0);

void _elm_code_widget_cursor_position_set(Eo *obj, Elm_Code_Widget_Data *pd, unsigned int row, unsigned int col);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_cursor_position_set, EFL_FUNC_CALL(row, col), unsigned int row, unsigned int col);

void _elm_code_widget_cursor_position_get(const Eo *obj, Elm_Code_Widget_Data *pd, unsigned int *row, unsigned int *col);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_code_widget_cursor_position_get, EFL_FUNC_CALL(row, col), unsigned int *row, unsigned int *col);

void _elm_code_widget_theme_refresh(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_code_widget_theme_refresh);

void _elm_code_widget_line_refresh(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Line *line);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_line_refresh, EFL_FUNC_CALL(line), Elm_Code_Line *line);

Eina_Bool _elm_code_widget_line_visible_get(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Line *line);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_line_visible_get, Eina_Bool, 0, EFL_FUNC_CALL(line), Elm_Code_Line *line);

unsigned int _elm_code_widget_lines_visible_get(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_code_widget_lines_visible_get, unsigned int, 0);

Eina_Bool _elm_code_widget_position_at_coordinates_get(Eo *obj, Elm_Code_Widget_Data *pd, int x, int y, unsigned int *row, int *col);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_position_at_coordinates_get, Eina_Bool, 0, EFL_FUNC_CALL(x, y, row, col), int x, int y, unsigned int *row, int *col);

Eina_Bool _elm_code_widget_geometry_for_position_get(Eo *obj, Elm_Code_Widget_Data *pd, unsigned int row, int col, int *x, int *y, int *w, int *h);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_geometry_for_position_get, Eina_Bool, 0, EFL_FUNC_CALL(row, col, x, y, w, h), unsigned int row, int col, int *x, int *y, int *w, int *h);

int _elm_code_widget_text_left_gutter_width_get(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_code_widget_text_left_gutter_width_get, int, 0);

char *_elm_code_widget_text_between_positions_get(Eo *obj, Elm_Code_Widget_Data *pd, unsigned int start_line, unsigned int start_col, unsigned int end_line, unsigned int end_col);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_text_between_positions_get, char *, NULL, EFL_FUNC_CALL(start_line, start_col, end_line, end_col), unsigned int start_line, unsigned int start_col, unsigned int end_line, unsigned int end_col);

void _elm_code_widget_text_at_cursor_insert(Eo *obj, Elm_Code_Widget_Data *pd, const char *text);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_text_at_cursor_insert, EFL_FUNC_CALL(text), const char *text);

unsigned int _elm_code_widget_line_text_column_width_to_position(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Line *line, unsigned int position);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_line_text_column_width_to_position, unsigned int, 0, EFL_FUNC_CALL(line, position), Elm_Code_Line *line, unsigned int position);

unsigned int _elm_code_widget_line_text_column_width_get(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Line *line);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_line_text_column_width_get, unsigned int, 0, EFL_FUNC_CALL(line), Elm_Code_Line *line);

unsigned int _elm_code_widget_line_text_position_for_column_get(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Line *line, unsigned int column);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_line_text_position_for_column_get, unsigned int, 0, EFL_FUNC_CALL(line, column), Elm_Code_Line *line, unsigned int column);

unsigned int _elm_code_widget_text_tabwidth_at_column_get(Eo *obj, Elm_Code_Widget_Data *pd, unsigned int column);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_code_widget_text_tabwidth_at_column_get, unsigned int, 0, EFL_FUNC_CALL(column), unsigned int column);

void _elm_code_widget_line_status_toggle(Eo *obj, Elm_Code_Widget_Data *pd, Elm_Code_Line *line);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_code_widget_line_status_toggle, EFL_FUNC_CALL(line), Elm_Code_Line *line);

void _elm_code_widget_undo(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_code_widget_undo);

Eina_Bool _elm_code_widget_can_undo_get(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_code_widget_can_undo_get, Eina_Bool, 0);

void _elm_code_widget_redo(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_code_widget_redo);

Eina_Bool _elm_code_widget_can_redo_get(Eo *obj, Elm_Code_Widget_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_code_widget_can_redo_get, Eina_Bool, 0);

Efl_Object *_elm_code_widget_efl_object_constructor(Eo *obj, Elm_Code_Widget_Data *pd);


Efl_Object *_elm_code_widget_efl_object_finalize(Eo *obj, Elm_Code_Widget_Data *pd);


Eina_Bool _elm_code_widget_efl_ui_widget_widget_input_event_handler(Eo *obj, Elm_Code_Widget_Data *pd, const Efl_Event *eo_event, Efl_Canvas_Object *source);


Eina_Error _elm_code_widget_efl_ui_widget_theme_apply(Eo *obj, Elm_Code_Widget_Data *pd);


static Eina_Bool
_elm_code_widget_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef ELM_CODE_WIDGET_EXTRA_OPS
#define ELM_CODE_WIDGET_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_code_set, _elm_code_widget_code_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_code_get, _elm_code_widget_code_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_font_set, _elm_code_widget_font_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_font_get, _elm_code_widget_font_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_columns_get, _elm_code_widget_columns_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_gravity_set, _elm_code_widget_gravity_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_gravity_get, _elm_code_widget_gravity_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_policy_set, _elm_code_widget_policy_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_policy_get, _elm_code_widget_policy_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_tabstop_set, _elm_code_widget_tabstop_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_tabstop_get, _elm_code_widget_tabstop_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_editable_set, _elm_code_widget_editable_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_editable_get, _elm_code_widget_editable_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_numbers_set, _elm_code_widget_line_numbers_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_numbers_get, _elm_code_widget_line_numbers_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_width_marker_set, _elm_code_widget_line_width_marker_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_width_marker_get, _elm_code_widget_line_width_marker_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_show_whitespace_set, _elm_code_widget_show_whitespace_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_show_whitespace_get, _elm_code_widget_show_whitespace_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_alpha_set, _elm_code_widget_alpha_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_alpha_get, _elm_code_widget_alpha_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_syntax_enabled_set, _elm_code_widget_syntax_enabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_syntax_enabled_get, _elm_code_widget_syntax_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_tab_inserts_spaces_set, _elm_code_widget_tab_inserts_spaces_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_tab_inserts_spaces_get, _elm_code_widget_tab_inserts_spaces_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_cursor_position_set, _elm_code_widget_cursor_position_set),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_cursor_position_get, _elm_code_widget_cursor_position_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_theme_refresh, _elm_code_widget_theme_refresh),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_refresh, _elm_code_widget_line_refresh),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_visible_get, _elm_code_widget_line_visible_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_lines_visible_get, _elm_code_widget_lines_visible_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_position_at_coordinates_get, _elm_code_widget_position_at_coordinates_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_geometry_for_position_get, _elm_code_widget_geometry_for_position_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_text_left_gutter_width_get, _elm_code_widget_text_left_gutter_width_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_text_between_positions_get, _elm_code_widget_text_between_positions_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_text_at_cursor_insert, _elm_code_widget_text_at_cursor_insert),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_text_column_width_to_position, _elm_code_widget_line_text_column_width_to_position),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_text_column_width_get, _elm_code_widget_line_text_column_width_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_text_position_for_column_get, _elm_code_widget_line_text_position_for_column_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_text_tabwidth_at_column_get, _elm_code_widget_text_tabwidth_at_column_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_line_status_toggle, _elm_code_widget_line_status_toggle),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_undo, _elm_code_widget_undo),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_can_undo_get, _elm_code_widget_can_undo_get),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_redo, _elm_code_widget_redo),
      EFL_OBJECT_OP_FUNC(efl_ui_code_widget_can_redo_get, _elm_code_widget_can_redo_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _elm_code_widget_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _elm_code_widget_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_input_event_handler, _elm_code_widget_efl_ui_widget_widget_input_event_handler),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _elm_code_widget_efl_ui_widget_theme_apply),
      ELM_CODE_WIDGET_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"columns", NULL, __eolian_elm_code_widget_columns_get_reflect},
      {"tabstop", __eolian_elm_code_widget_tabstop_set_reflect, __eolian_elm_code_widget_tabstop_get_reflect},
      {"editable", __eolian_elm_code_widget_editable_set_reflect, __eolian_elm_code_widget_editable_get_reflect},
      {"line_numbers", __eolian_elm_code_widget_line_numbers_set_reflect, __eolian_elm_code_widget_line_numbers_get_reflect},
      {"line_width_marker", __eolian_elm_code_widget_line_width_marker_set_reflect, __eolian_elm_code_widget_line_width_marker_get_reflect},
      {"show_whitespace", __eolian_elm_code_widget_show_whitespace_set_reflect, __eolian_elm_code_widget_show_whitespace_get_reflect},
      {"alpha", __eolian_elm_code_widget_alpha_set_reflect, __eolian_elm_code_widget_alpha_get_reflect},
      {"syntax_enabled", __eolian_elm_code_widget_syntax_enabled_set_reflect, __eolian_elm_code_widget_syntax_enabled_get_reflect},
      {"tab_inserts_spaces", __eolian_elm_code_widget_tab_inserts_spaces_set_reflect, __eolian_elm_code_widget_tab_inserts_spaces_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _elm_code_widget_class_desc = {
   EO_VERSION,
   "Elm.Code_Widget",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Elm_Code_Widget_Data),
   _elm_code_widget_class_initializer,
   _elm_code_widget_class_constructor,
   NULL
};

EFL_DEFINE_CLASS(elm_code_widget_class_get, &_elm_code_widget_class_desc, EFL_UI_LAYOUT_CLASS, NULL);
